\documentclass{report}
\usepackage{geometry}                % See geometry.pdf to learn the layout options. There are lots.
\geometry{a4paper}                   % ... or a4paper or a5paper or ... 
%\geometry{landscape}                % Activate for for rotated page geometry
%\usepackage[parfill]{parskip}    % Activate to begin paragraphs with an empty line rather than an indent
\usepackage{graphicx}
\usepackage{amssymb,amsmath}
\usepackage{epstopdf}
\usepackage{fullpage}
\usepackage{verbatim}
\usepackage{courier}
\usepackage[colorlinks, linkcolor=blue]{hyperref}
\usepackage{bm}
\DeclareGraphicsRule{.tif}{png}{.png}{`convert #1 `dirname #1`/`basename #1 .tif`.png}

\def \k{\mathbf{\hat{\Omega}}}
\def \p{\prime}
\def \i {\mathfrak{i}}
\def \T{{\Delta t}}
\def \F{{\Delta f}}
\def \d{\mathrm{d}}
\def \ft{\widetilde}
\def \D{\mathbf{\Delta x}}
\def \x{\mathbf{x}}
\def \Om{\mathbf{\hat{\Omega}}'}
\def \DelOm{\mathbf{\Delta\Omega}}
\def \P{\mathcal{P}}
\def \q{\mathbf{\hat{q}}}
\def \Pest{\hat{\bm{\mathcal{P}}}}
\def \Npix{N_{\mathrm{pix}}}
\def \Nb{N_{\mathrm{b}}}

\newcommand{\link}[1]{\hyperref[#1.m]{\tt #1}}


%\title{Map Estimator (mapEst) Manual}
%\author{Sanjit Mitra $<$sanjit.mitra@ligo.org$>$}
%\date{}                                           % Activate to display a given date or no date

\begin{document}
\begin{titlepage}
\mbox{}% to get into horizontal mode
\vfill
\begin{center}
\huge{\bf Map Estimator (mapEst) Documentation}
~\\
~\\
~\\
~\\
\includegraphics[width=0.75\textwidth]{smiley}
~\\
\href{mailto:sanjit.mitra@ligo.org}{\Large{Sanjit Mitra $<$sanjit.mitra@ligo.org$>$}}
~\\
~\\
\end{center}
\vfill
\end{titlepage}

\tableofcontents

~\newline
Codes tested with MATLAB R2007a.

\newpage

\setcounter{chapter}{-1}
\chapter{Quick Start}
\label{ch:QS}

The Map-Estimator (mapEst) program computes the Maximum Likelihood estimate of the true skymap of the gravitational wave background (GWB). It first makes a raw skymap using the GW radiometer analysis from the Fourier transforms of small chunks of detector outputs $\ft{s}(t,f)$ at different sidereal times. Then it computes the beam matrix for the radiometer and uses that to estimate the true sky map.

The following commands can be used to get some quick results. All the paths are relative to the {\tt ../src} directory. For details of the theory and the functions, see the rest of this documentation.\\

***~BE CAREFUL while replacing a beam file, calculation of beam matrix can take hours to days~***
\begin{enumerate}
\item Dirty map + Clean map -- Beam matrix (beam matrix will be read, not calculated):
%
\begin{verbatim}
[ theta, phi, sourceMap, dirtyMap, cleanMap, b, variance ] = mapEst ...
('L1','H1','../pixels/HEALPix-768.dat', '../inject/source-point-768.dat', ...
'../beams/beam-SRD-H0-768.dat', '../output/test-768.dat', 'mollweid',0,1,1);
\end{verbatim}
%
\begin{tabular}{|r|l|}\hline\hline
Input Arguments & Description \\\hline
{\tt 'L1','H1'} & Detector names\\
{\tt '../pixels/HEALPix-768.dat'} & Pixel file with $768$ pixels.\\
~ & More pixel files in {\tt ../pixels} directory\\
{\tt '../inject/source-point-768.dat'} & Injected source map\\
~ & Col 1: pixel indices of injection points, Col 2: strength\\
~ & More source files in {\tt ../inject} directory\\
{\tt '../beams/beam-SRD-H0-768.dat'} & File for read/write Beam matrix for 768 pixels\\
~ & More beam files in {\tt ../beams} directory\\
{\tt '../output/test-768.dat'} & Output file: source, dirty and clean maps\\
~ & and normalization constant for each pixel\\
{\tt 'mollweid'} & Projection type for plotting\\
{\tt 0} & DO NOT compute the beam matrix\\
{\tt 1} & Simulate signal using the map file\\
{\tt 1} & Apply a multiplicative factor of ``1'' to each source pixel\\\hline\hline
Returned Quantities & Description \\\hline
{\tt theta, phi} & The pixel coordinate vectors\\
~ & Each component is a pixel\\
{\tt sourceMap} & Vector containing the injected skymap\\
{\tt dirtyMap} & Vector containing the raw/dirty skymap\\
{\tt cleanMap} & Vector containing the clean skymap\\
{\tt b} & UNNORMALIZED beam matrix\\
{\tt variance} & Variance of dirty map at each pixel\\
\hline\hline\end{tabular}\\
These arguments have the same meaning over the whole document.

The default deconvolution routine is biconjugate gradient numerically stabilized method. To get a deconvolved map with another method, e.g. with minimum residual method use:
\begin{verbatim}
cleanMap = minres (b, dirtyMap);
\end{verbatim}
The default deconvolution scheme can be changed by editing the source file {\tt deconvolve.m}. One can also choose the maximum number of iterations and the tolerance limits arguments for most of the linear equation solvers.  The output matrix {\tt b} and the map {\tt dirtyMap} are both unnormalized. This is done in order to make the ``kernel'' {\tt b} in the linear equation symmetric, which is required by some of the linear equation solver routines. To normalize beam and dirty map use:
\begin{verbatim}
normalizedB = repmat (4*variance, 1, length(variance)) .* b;
normalizedDirtyMap = 4*variance .* dirtyMap;
\end{verbatim}
%
The default value of the lower cut-off frequency, upper cut-off frequency and frequency bin size are $40$~Hz, $512$~Hz and $2$~Hz respectively. The default total time\footnote{A sidereal day has been taken as $86400$~sec, but the correct value is $86164$~sec\newline [See, eg. \url{http://en.wikipedia.org/wiki/Sidereal_day}]} and time bin size are $86400$~sec and $192$~sec respectively. To change these setting edit the file {\tt mapEst.m}. The default noise PSD correspond to LIGO S5 run. In order change the noise PSDs and simulated noise characteristics modify the file {\tt getData.m}. This file should be replaced in order to use real data.

\item Dirty map + Clean map + Beam matrix (can take hours to days):
\begin{verbatim}
[ theta, phi, sourceMap, dirtyMap, cleanMap, b, variance ] = mapEst ...
('L1','H1','../pixels/HEALPix-768.dat', '../inject/source-point-768.dat', ...
'../beams/beam-SRD-H0-768.dat', '../output/test-768.dat', [],1,1,1);\end{verbatim}
%
The last argument, {\tt 1}, forces the computation of beam matrix. Beam matrix is now {\em written} to the file {\tt '../beams/beam-test-768.dat'}. Some extra time is available if the last argument was put by mistake, PRESS {\tt Ctrl+C} IMMEDIATELY to stop overwriting the beam file. The seventh argument {\tt 'mollweid'} is now removed to disable plotting - usually beam matrix is calculated in the batch mode as it takes long time, plotting can be done later from the saved output data files.

\item Only dirty map (if noise is added) or beam pattern for pointing directions listed in the {\tt inputMap}:
\begin{verbatim}
[ theta, phi, sourceMap, dirtyMap, variance ] = dirtyMapTest ('L1','H1', ...
'../pixels/HEALPix-768.dat','../inject/source-point-768.dat', ...
0,'../output/dirtyMapTest-768.dat', 'mollweid');
\end{verbatim}
This command will only make the raw map using the radiometer analysis without noise.

\item Load saved data:

\begin{verbatim}
[ theta, phi, sourceMap, dirtyMap, cleanMap, variance] = ...
loadMap ('../output/map-test-768.dat');
\end{verbatim}
will read the file {\tt ../output/map-test-768.dat} and load injected, dirty and clean maps and the pixel coordinates. The command
\begin{verbatim}
[ b, variance ] = loadBeam ('../beams/beam-test-768.dat');
\end{verbatim}
will load the beam from file {\tt ../beams/beam-test-768.dat}. Since these files are usually read for deconvolution study, beam matrix and the dirty map will be unnormalized after loading.

\item Visualization:

To plot the clean map using Mollweid projection scheme use
\begin{verbatim}
xproject ([ theta, phi ], cleanMap, 'mollweid');
\end{verbatim}
Replace {\tt 'mollweid'} by {\tt 'sphere'} to get a 3D spherical plot.

\end{enumerate}

\chapter{Theory}

The basic theory to make maximum likelihood estimate of the true gravitational wave background sky from a single baseline radiometer skymap has been briefly described here. A filter optimized to detect delta function like sources has been used to make the raw skymap. We assume equal power in each polarization component and that the source power spectrum does not vary with direction.

\section{Making a ``dirty'' map}

In the GW radiometer analysis, outputs from two detectors are correlated with a time dependent directional filter. Correlations for each direction $\k$ are performed over shorter time intervals of $\T$ and finally these correlations are combined as a weighted sum to generate the ``dirty" map. Mathematically, in the discretized case, the point estimate at the $i^{th}$ pixel at $\k_i$ is

\begin{equation}
S_i \ := \ S(\k_i) \ = \ 2 \, \Lambda_i \, \sum_{t=0}^T \Re \left[ \F \sum_{f=f_l}^{f_u} \ft{s}_1^*(t,f) \, \ft{s}_2(t,f) \, \ft{q}_{\k_i}(t,f) \right]; \qquad \Lambda_i \ := \ \left[ \T \sum_{t=0}^T \lVert q_{\k_i} \rVert_t^2 \right]^{-1},
\end{equation}
%
where $f_l$ and $f_u$ are the lower and upper frequency cut-offs respectively and $\ft{s}_I(t,f)$ is the Fourier transform of time series output obtained from detector $I=1,2$ during the time interval $t-\Delta t/2$ to $t+\Delta t/2$. The filter $q_\k$ in time-frequency domain is given by
\begin{equation}
\ft{q}_\k(t,f) \ = \ \frac{H(|f|) \, \gamma^*(\k,t,|f|)}{P_1(t,|f|) \, P_2(t,|f|)}
\end{equation}
%
and its norm for segment $t$ is defined as
\begin{equation}
\lVert q_{\k} \rVert_t^2 \ = \ \F \sum_{f=f_l}^{f_u} \left| \ft{q}_\k(t,f) \right|^2.
\end{equation}
%
The time dependent overlap reduction function $\gamma(\k,t,f)$ can be expressed as
\begin{equation}
\gamma(\k,t,f) \ = \ e^{2\pi \i f \k\cdot\D(t)/c} \left[ F^+_1(\k,t) \, F^+_2(\k,t) \ + \ F^\times_1(\k,t) \, F^\times_2(\k,t) \right],
\end{equation}
%
where $F^A_I(\k,t)$ is the antenna response function of detector $I=1,2$ for polarization $A=+,\times$ and $\D(t)$ is the rotating baseline vector.
%
The variance and SNR at the $i^{th}$ pixel $\rho_i$ are given by
\begin{equation}
\sigma_i^2 \ = \ \Lambda_i/4 \ = \ {1 \over 4} \left[ \T \sum_{t=0}^T \lVert q_{\k_i} \rVert_t^2 \right]^{-1}; \qquad \rho_i \ = \ S_i/\sigma_i.
\end{equation}

\section{Injection scheme (Optional)}

Fourier transform of a chunk of detector output $\ft{s}_I(t,f)$ at a certain time $t$ from any detector $I$ consists of the true gravitational wave strain part $\ft{h}_I(t,f)$ and the noise part $\ft{n}_I(t,f)$:
\begin{equation}
\ft{s}_I(f,t) \ = \ \ft{h}_I(f,t) + \ft{n}_I(f,t).
\end{equation}
 We generate Gaussian random noise and color it with detector noise power spectrum density $P_I(t,f)$ to simulate $\ft{n}_I(t,f)$. Instead of generating $\ft{h}_I(t,f)$ separately for each detector, we use the correlation between the true gravitational wave strain parts in two detectors $I=1,2$
\begin{equation}
\langle \ft{h}^*_1(t;f) \, \ft{h}_2(t;f') \rangle \ = \ \delta_{ff'} \, H(|f|) \, \sum_i \P_i \,  \gamma(\k_i,t,|f|)
\end{equation}
%
where $\P_i$ is the strength of a source at the $i^{th}$ pixel. The assumption is that the sky is a collection of uncorrelated point sources. Since we can always write
\begin{eqnarray}
\ft{s}_1^*(t,f) \, \ft{s}_2(t,f) &=& \ft{h}_1^*(t,f) \, \ft{h}_2(t,f) \ + \ \ft{n}_1^*(t,f) \, \ft{n}_2(t,f) \\
\ft{h}_1^*(t,f) \, \ft{h}_2(t,f) &=& \langle \ft{h}_1^*(t,f) \, \ft{h}_2(t,f) \rangle \ + \ \text{fluctuations}
\end{eqnarray}
and the ``fluctuations'' in $\ft{h}_1^*(t,f) \, \ft{h}_2(t,f)$ are statistically much smaller than the detector noise term $\ft{n}_1^*(t,f) \, \ft{n}_2(t,f)$, we simulate data with signal using the formula
\begin{equation}
\ft{s}_1^*(t,f) \, \ft{s}_2(t,f) \ = \ \langle \ft{h}_1^*(t,f) \, \ft{h}_2(t,f) \rangle \ + \ \ft{n}_1^*(t,f) \, \ft{n}_2(t,f).
\end{equation}

\section{Computation of Beam Matrix}
The observed skymap can be expressed as
\begin{equation}
S_i \ = \ \sum_{j=1}^{\Npix} B_{ij} \,  \P_j \ + \ n_i, \label{eq:linConv}
\end{equation}
where the pixel noise
\begin{equation}
n_i \ = \ 2  \, \Lambda_i \, \sum_{t=0}^T  \Re \left[ \F \sum_{f=f_l}^{f_u} \ft{n}_1^*(t,f) \, \ft{n}_2(t,f) \, \ft{q}_{\k_i}(t,f) \right]
\end{equation}
the beam matrix and the "unnormalized (symmetric) beam" matrices are
\begin{equation}
B_{ij} \ := \ \Lambda_i \,b_{ij}, \qquad b_{ij} \ := \ 2 \, \T \, \sum_{t=0}^T \Gamma(\k_j,t) \, \Gamma(\k_i,t)  \, \Re \left[ \F \sum_{f=f_l}^{f_u} e^{2\pi \i f (\k_j-\k_i)\cdot\D(t)/c} G(t,f) \right].
\end{equation}
%
The antenna pattern function are contained in the variable
\begin{equation}
\Gamma(\k,t) \ := \  F^+_1(\k,t) F^+_2(\k,t) + F^\times_1(\k,t) F^\times_2(\k,t) \label{eq:Gamma}
\end{equation}
and the power spectral densities of the source and detectors are contained by
\begin{equation}
G(t,f) := H^2(f)/[P_1(t,f) P_2(t,f)].
\end{equation}
%
The antenna pattern functions $F^A(\k,t)$ for each polarization $A=+,\times$ and detector $I=1,2$ and the detector separation vector $\D(t)$ are calculated at all sidereal time bins using the  Euler rotation matrix about the earth's rotation axis ($z$-axis)
\begin{equation}
\mathbf{R}^{(z)}(\phi) \ := \
\left[\begin{array}{rrr}
 \cos\phi & \sin\phi & 0\\
-\sin\phi & \cos\phi & 0\\
        0        &         0         & 1
\end{array}\right]
\end{equation}
using the following formulae
\begin{eqnarray}
F_I^A(\k,t) &=& \sum_{i=1}^3 \sum_{j=1}^3 e^A_{ij}(\k) \left[ \sum_{p=1}^3 \sum_{l=1}^3 R^{(z)}_{ip}(-\omega_E t) \, d^I_{pl} \, R^{(z)}_{lj}(\omega_E t) \right]\\
\mathbf{d}^I &=& \frac{1}{2} \left[ \mathbf{\hat{X}}_I \otimes \mathbf{\hat{X}}_I \ - \ \mathbf{\hat{Y}}_I \otimes \mathbf{\hat{Y}}_I \right]\\
\left[ \D(t) \right]_i &=& \sum_{q=1}^3 R^{(z)}_{iq}(-\omega_E t) \, \left[ \D(t=0) \right]_q.
\end{eqnarray}
%
Here $\omega_E$ is the Earth's (sidereal) angular velocity, $\mathbf{d}^I$ are the detector tensors, $\mathbf{\hat{X}}_I,\mathbf{\hat{Y}}_I$ are detector arm unit vectors at $t=0$, the symbol $\otimes$ denotes outer product and the polarization tensors $\mathbf{e}^A(\k)$ for a direction $\k$ with spherical polar coordinates $(\theta, \phi)$ are defined by the following set of equations:
\begin{eqnarray}
\mathbf{m} &:=& (\sin\phi, \ -\cos\phi, \ 0)\\
\mathbf{n} &:=& (-\cos\theta \, \cos\phi, \ -\cos\theta \, \sin\phi, \ \sin\theta)\\
\mathbf{e}^+ &:=& \mathbf{m} \otimes \mathbf{m} \ - \ \mathbf{n} \otimes \mathbf{n}\\
\mathbf{e}^\times &:=& \mathbf{m} \otimes \mathbf{n} \ + \ \mathbf{n} \otimes \mathbf{m}.
\end{eqnarray}


We calculate each of the geometric parts $\sum_t \lVert q_{\k_i} \rVert_t^2$, $\Gamma(\k,t)$ and $\D(t)$ in the beginning. Then from the (simulated) data it calculates $G(t,f)$. Pre-computation of these quantities is possible because they depend on any two of the three indices - pixel, time and frequency, hence storing these quantities does not require very large memory/disk space. The final step to calculate the beam matrix is similar to a matrix multiplication, with an extra exponential [$\exp\{2\pi i f (\k_j-\k_i)\cdot\D(t)/c\} $] call for each element.

\section{Deconvolution}

The maximum likelihood estimate of the true sky in this special case is given by
\begin{equation}
\Pest \ = \ \mathbf{B}^{-1} \cdot \mathbf{S}.
\end{equation}
%
However, it is difficult to invert the (sparse) beam matrix. Rather we solve the linear algebraic equation
\begin{equation}
\mathbf{B} \cdot \Pest  \ = \ \mathbf{S} \qquad \Rightarrow \ \sum_j b_{ij} \cdot \hat{\P}_j  \ = \ S_i/\Lambda_i.
\end{equation}
%
Several methods to solve linear algebraic equation have been tried, but only the conjugate gradient method seems to work. Different conjugate gradient methods are inbuilt in MATLAB, all of them provide nearly the same result, but the bi-conjugate gradient numerically stabilized method seems slightly better.

\section{Covariance Matrix}

Only the Maximum Likelihood estimate is not sufficient to study for statistical study of the estimated map. The variance at each pixel of the deconvolved map is necessary (i) to compare the performances of different deconvolution algorithms and (ii) to put upper limit on the true sky. The expression for the covariance matrix of the deconvolved map
\begin{equation*}
\mathbf{\Sigma} \ := \ \langle (\Pest - \langle\Pest\rangle) (\Pest - \langle\Pest\rangle)^T \rangle \ = \ \left( \mathbf{B}^T \, \mathbf{N}^{-1} \, \mathbf{B} \right)^{-1},
\end{equation*}
where the covariance matrix of the dirty map  for the case considered here is given by
\begin{equation}
N_{ij} \ = \ {1 \over 4} \Lambda_j \, B_{ij} \ = \ {1 \over 4} \Lambda_i \, \Lambda_j \, b_{ij}.
\end{equation}
%
Computation of the covariance matrix requires the inverse of the beam matrix ($\mathbf{B}^{-1}$), which was bypassed while estimating the true skymap by solving a linear equation. It has not been possible so far to invert the beam matrix, and hence, to evaluate the covariance matrix of the deconvolved skymap.

\chapter{Main Functions}

\section{mapEst.m}
\label{mapEst.m}

\subsection*{Syntax:}

\begin{verbatim}
This is the main script that calls the other routines.

[ theta, phi, sourceMap, dirtyMap, cleanMap, b, variance ] = ...
    mapEst (detector1, detector2, pixelFile, inputMap, beamFile, mapFile, ...
        projType, computeBeam, simulate, strength)

 detector1      String. Detector name 1 (like 'L1', 'H1', ...)
 detector2      String. Detector name 2 (like 'L1', 'H1', ...)
 pixelFile      String. File containing the pixel coordinates in radian
                Column 1: longitude, Column 2: latitude
 inputMap       Real Matrix or String. Source or dirty map or filename
                If simulate = 1: Injected pixels or the filename
                  Column 1: pixel numbers, Column 2: corresponding strength
                Otherwise: Full sky source and dirty maps or filename
                  Column 3: source map, Column 4: dirty map, Column 6: variance
 beamFile       String. Beam matrix will be read from this file
                *** except when computeBeam (8th argument) is 1 ***
                The beam matrix can itself be supplied, instead of filename
                Full Beam matrix will be computed if computeBeam=1 and
                the matrix will be written to the file
                Column 1,2: pixel indices, Column 2: beam, Column 3: variance
 mapFile        String. File to write the maps to
 projType       String. Optional. If specified the skymaps will be plotted
                using that projType as the projection type, e.g., 'mollweid'
 computeBeam    Boolean. Optional. If 1, full beam matrix will be computed
                and written to beamFile instead of reading it
 strength       Real. Overall multiplicative factor for the sourceMap

 theta          Real vector. Polar angles of the pixels
 phi            Real vector. Azimuthal angles of the pixels
 sourceMap      Real vector. (Optional) Injected map of the sky
 dirtyMap       Real vector. Raw/dirty/concolved map of the sky
                Each component corresponds to a pixel
 cleanMap       Real vector. Estimated/clean/deconvolved map of the sky
                Each component corresponds to a pixel
 b              Real matrix. Unnormalized beam matrix
 variance       Real vector. Variance at each pixel
\end{verbatim} 

\subsection*{Description:}

The main routine of this package. Whole analysis can be carried out by calling only this routine. \hyperref[ch:QS]{Quick Start chapter} contains a detailed description of how to make a test map with this routine.

The work flow of this routine is given below:
\begin{enumerate}

\item Define the positions of the time bins {\tt timeBins} and the frequency bins {\tt freqBins}. These bins can be changes by modifying the file {\tt mapEst.m}.

\item Load the pixel coordinates {\tt [ theta, phi ]} from {\tt pixelFile}. the {\em first} column of {\tt pixelfile} is longitute and the {\em second} column is latitude. Then calculate the direction unit vectors {\tt pixOmega} [$\k_i$] for each pixel. The azimuthal coordinates are translated to fit the range $-\pi \le \phi < \pi$.

\item Get detector data using the routine \link{LoadDetectorData}. We only need detector tensors [$\mathbf{d}^{1,2}$] and coordinates. Find the initial detector separation vector {\tt detSep0} [$\D(t=0)$] from this data.

\item Read source coordinates and strengths from {\tt sourceFile}, then complete the full source map {\tt sourceMap} [$\bm{\P}$] by putting zeros at other pixels.

\item Compute the Euler rotation matrices {\tt EulerZ} [$\mathbf{R}^{(z)}(\omega_E t)$] about earth's spin axis for all sidereal time bins using the \link{EulerRotationZ} routine.

\item Construct detector separation vectors {\tt detSep} [$\D(t)$] for all sidereal time bins by Euler rotation of the initial detector separation {\tt detSep0} about the earth's spin axis using the \link{rotateDetSep} function.

\item Calculate the combination of antenna pattern functions {\tt Gamma} [$\Gamma(\k_i,t)$] using the routine \link{overlap}.

\item Load {\tt s1s2}, {\tt P1}, {\tt P2}, {\tt invP1} and {\tt invP2} [$\langle\ft{n}_1^*(t,f) \, \ft{n}_2(t,f)\rangle$, $P_{1,2}(t,f)$ and $P_{1,2}^{-1}(t,f)$ respectively] using \link{getData}. To include real data, modify the file {\tt getdata.m}.

\item Get the source PSD and its inverse {\tt H} and {\tt invH} using the routine \link{sourcePSD} and, if {\tt simulate=1}, inject GW signal {\tt h1h2} [$\langle\ft{h}_1^*(t,f) \, \ft{h}_2(t,f)\rangle$] due to the GW signal coming from all the points from the sky described by {\tt sourceMap} using \link{injectSignal}. Add {\tt h1h2} to {\tt s1s2}.

\item Pre-compute the spectral densities of the source and detector and store in {\tt fSpectrum} [$G(t,f)$].

\item Compute the variance (normalization constant/4) {\tt variance} [$(\T \sum_{t=0}^T \lVert q_{\k_i} \rVert_t^2)^{-1}$] for each pixel using the routine \link{normalize}.

\item Make an UNNORMALIZED dirty map of the sky {\tt dirtyMap} [$\mathbf{S}$] using \link{makeRawMap}. Each row of {\tt dirtyMap} corresponds to a pixel.

\item If the eighth argument is {\tt 1}, compute the UNNORMALIZED beam matrix {\tt B} [$(\T \sum_{t=0}^T \lVert q_{\k_i} \rVert_t^2) B_{ij}$] using the routine \link{beamMatrix} and store the normalized matrix to the file {\tt beamFile}. The first two columns of {\tt beamFile} are the pixel indices, the third column is the corresponding element of the NORMALIZED beam matrix and the last column is {\tt variance}.

If the eighth component is not {\tt 1} or not supplied, normalized beam matrix and {\tt variance} are read from {\tt beamFile} and then the unnormalized beam matrix {\tt B} is constructed.

\item Deconvolve using the routine \link{deconvolve} to get the estimated map {\tt cleanMap} [$\Pest$].

\item The injected, dirty and clean maps will be plotted using the utility \link{xproject} if an available projection type {\tt projType} is supplied as the seventh argument. Currently available options are {\tt 'mollweid'} and {\tt 'sphere'}. This routine requires the azimuthal coordinates to be inside $[-\pi,\pi)$.

\item The normalized maps and the normalization constants will be written to the output file {\tt mapFile}. each row of the output file will have the pixel coordinates and source, dirty and clean maps along with the normalization constant.

\end{enumerate}

This package is not equipped with thorough argument checks - be careful while using it.


\newpage

\section{LoadDetectorData.m}
\label{LoadDetectorData.m}
By: P. Sutton, 2 Feb 2006

\subsection*{Syntax:}

\begin{verbatim}
 LoadDetectorData: Return a struct containing data on the location and 
 orientation and orientation of the specified gravitational-wave detector 
 or detector site.

   Det = LoadDetectorData(detector)

   detector  String. Detector site of interest.  Available detectors are 
             'ALLEGRO' (or 'AL'), 'AURIGA' (or 'AU'), 'EXPLORER' (or
             'EX'), 'GEO' (or 'G1', 'G'), 'LHO' (or 'H1', 'H2', 'H'),
             'LLO' (or 'L1', 'L'), 'NAUTILUS' (or 'NA'), 'NIOBE' (or
             'NI'), 'TAMA' (or 'T1', 'T'), and 'VIRGO' (or 'V1', 'V').

   Det       Struct containing data on the detector site.  The fields are:

               Det.d       Antenna response matrix.  For IFOs this is
                             Det.d = 1/2*(Det.X*Det.X'-Det.Y*Det.Y');
                           For bars this is
                             Det.d = Det.n*Det.n'-[1 0 0; 0 1 0; 0 0 1]/3;
               Det.h       Detector elevation (m).
               Det.lambda  Detector longitude (deg E of N).
               Det.n       Bar pointing direction in Cartesian Earth-based
                           coordinates ([] for IFOs).
               Det.name    Name of detector (abbreviated form: one letter 
                           for IFOs, two letters for bars)
               Det.phi     Detector latitude (deg N).
               Det.psi     Detector azimuth / bar pointing direction (deg 
                           W of N, [] for IFOs).
               Det.V       Location of vertex/beamsplitter (IFOs) or bar 
                           in Cartesian Earth-based coordinates (m).
               Det.X       X arm pointing direction ([] for bars).
               Det.Y       Y arm pointing direction ([] for bars).
               Det.Z       Right-handed direction orthogonal to the 
                           detector X-Y plane (IFOs), or zenith sky
                           direction at the detector (bars). 

 All data for interferometers follow the WGS-84 model. For bar detectors
 the data assume a spherical Earth. As a result, the antenna response
 factors (F+, Fx) for bars are only accurate to the 1% level.
\end{verbatim}

\subsection*{Description:}

Loads the detectors data for the supplied detector name argument. In this package we use the detector's latitude {\tt Det.lambda} and longitude {\tt Det.phi} and the detector tensors {\tt Det.d} [$\mathbf{d}$].

\newpage

\section{EulerRotationZ.m}
\label{EulerRotationZ.m}

\subsection*{Syntax:}

\begin{verbatim}
 Compute Euler rotation matrices about the Z-axis at all sidereal times

 EulerZ = EulerRotationZ (timeBins)

 timeBins Real vector. The array of midpoints of sidereal time bins

 EulerZ   3-dimensional array. Last index is for sidereal time and 
          the first two are for Euler matrices
\end{verbatim}

\subsection*{Description:}

Computes the Euler rotation matrix at all sidereal time bins {\tt EulerZ} using the formula
\begin{equation*}
\mathbf{R}^{(z)}(\omega_E t) \ := \
\left[\begin{array}{rrr}
 \cos(\omega_E t) & \sin(\omega_E t) & 0\\
-\sin(\omega_E t) & \cos(\omega_E t) & 0\\
        0        &         0         & 1
\end{array}\right].
\end{equation*}
The returned quantity is a three indexed object. The last index is for sidereal time, the first two are used to store the $3\times3$ Euler matrix.

\newpage

\section{rotateDetSep.m}
\label{rotateDetSep.m}

\subsection*{Syntax:}

\begin{verbatim}
 Compute the detector separation vector at each sidereal time

 detSep = rotateDetSep (detSep0, EulerZ)

 detSep0   Real vector. Initial detector separation vector
 EulerZ    3-dim array. First two indices are for Euler matrix
           Third index is for sidereal time

 detSep    Real matrix. Detector separation vector at all sideral times
           Index 1: Vector component, Index 2: sidereal time
\end{verbatim}

\subsection*{Description:}

Given the Euler rotation matrices about earth's spin axis {\tt EulerZ} [$\mathbf{R}^{(z)}(\Omega_E t)$] at all sidereal time bin and the initial detector separation vector {\tt detSep0} [$\D(t=0)$], this routine returns the detector separation vector {\tt detSep} at all sidereal time bins using the formula
\begin{equation*}
\left[ \D(t) \right]_i \ = \ \sum_{q=1}^3 R^{(z)}_{iq}(-\omega_E t) \, \left[ \D(t=0) \right]_q.
\end{equation*}

\newpage

\section{overlap.m}
\label{overlap.m}
Formula copied from a code originally written by P. Sutton, 26 Apr 2006.

\subsection*{Syntax:}

\begin{verbatim}
 Compute "Gamma" - a combination of the antenna pattern functions for the
 all the pixels and a pair of detectors at all sidereal times  

 Gamma = overlap (theta, phi, EulerZ, d1, d2)

 theta    Real vector. Polar angles of the pixels
 phi      Real vector. Azimuthal angles of the pixels
 EulerZ   3-dimensional array. Last index is for sidereal time and 
          the first two are for euler matrices
 d1       3x3 real array.  The response matrix d_{ab} of detector 1
 d2       3x3 real array.  The response matrix d_{ab} of detector 2

 Gamma    Real matrix. Combination of antenna patterns for all directions
          and sideral times. Index 1: pixel, Index 2: sidereal time
          *** CAUTION: Gamma is NOT the full overlap reduction function ***
\end{verbatim}

\subsection*{Description:}

Given the Euler matrices at all the sidereal time bins  {\tt EulerZ} [$\mathbf{R}^{(z)}(\Omega_E t)$], detector tensors {\tt d1}, {\tt d2} [$\mathbf{d}^{1,2}$], the pixel coordinates {\tt [ theta, phi ]} [$\theta_i,\phi_i$] and the following set of equations,
\begin{eqnarray*}
\mathbf{m} &:=& (\sin\phi, \ -\cos\phi, \ 0)\\
\mathbf{n} &:=& (-\cos\theta \, \cos\phi, \ -\cos\theta \, \sin\phi, \ \sin\theta)\\
\mathbf{e}^+ &:=& \mathbf{m} \otimes \mathbf{m} \ - \ \mathbf{n} \otimes \mathbf{n}\\
\mathbf{e}^\times &:=& \mathbf{m} \otimes \mathbf{n} \ + \ \mathbf{n} \otimes \mathbf{m}\\
F_I^A(\k,t) &=& \sum_{i=1}^3 \sum_{j=1}^3 e^A_{ij}(\k) \left[ \sum_{p=1}^3 \sum_{l=1}^3 R^{(z)}_{ip}(-\omega_E t) \, d^I_{pl} \, R^{(z)}_{lj}(\omega_E t) \right]\\
\mathbf{d}^I &=& \frac{1}{2} \left[ \mathbf{\hat{X}}_I \otimes \mathbf{\hat{X}}_I \ - \ \mathbf{\hat{Y}}_I \otimes \mathbf{\hat{Y}}_I \right]\\
\Gamma(\k,t) &:=&  F^+_1(\k,t) F^+_2(\k,t) + F^\times_1(\k,t) F^\times_2(\k,t)
\end{eqnarray*}
The routine returns {\tt Gamma} [$\Gamma(\k_i,t)$] for all pixels at all sidereal time bins. The overlap reduction function can be obtained by the equation
\begin{equation*}
\gamma(\k,t,f) \ = \ \Gamma(\k,t)  \, e^{2\pi \i f \k\cdot\D(t)/c}.
\end{equation*}

\newpage

\section{getData.m}
\label{getData.m}

\subsection*{Syntax:}

\begin{verbatim}
 *** To use real data this function should be modified ***
 Presently this function generates noise only

 [ s1s2, P1, P2, invP1, invP2 ] =
  getData (detector1, detector2, timeBins, freqBins)

 detector1    String. Detector name 1 (like 'L1', 'H1', ...)
 detector2    String. Detector name 2 (like 'L1', 'H1', ...)
 timeBins     Real vector. Position of time bins
 freqBins     Real vector. Position of frequency bins

 P1, P2       Real matrix. Noise PSDs of detectors at all time bins
              Index 1: time, Index 2: frequency
 invP1,invP2  Real matrix. Inverse of detector noise PSDs at all time bins
              Index 1: time, Index 2: frequency
 s1s2         Complex matrix. s1*(f)s2(f) at all time bins
              Index 1: time, Index 2: frequency
\end{verbatim}

\subsection*{Description:}

The noise spectral densities {\tt P1}, {\tt P2} [$P_{1,2}(t,f)$] and their inverse arrays {\tt invP1}, {\tt invP2} [$1/P_{1,2}(t,f)$] are calculated by this routine. The inverse of the power spectrum is set to zero, wherever the power spectrum is zero.

This routine also simulates Fourier transform of detectors' time series data at all the time and frequency bins by a MATLAB inbuilt Gaussian random number generator {\tt randn}. The noise is colored by detector PSDs. The returned value is the product of simulated data for two detectors  {\tt s1s2} [$\langle\ft{n}_1^*(t,f) \, \ft{n}_2(t,f)\rangle$].

\newpage


\section{sourcePSD.m}
\label{sourcePSD.m}

\subsection*{Syntax:}

\begin{verbatim}
 Returns the arrays containing H(f) and 1/H(f)

 [ H, invH ] = sourcePSD (freqBins)

 freqBins   Vector. Position of frequency bins

 H          Real vector. Frequency power spectrum of the source
 invH       Real vector. Inverse of frequency power spectrum of the source
\end{verbatim}

\subsection*{Description:}

This routine generates the power spectral density of the source {\tt H} [$H(f)$] using a power law
\begin{equation*}
H(f) \ = \ H_\alpha \, f^\alpha,
\end{equation*}
the coefficients {\tt HAlpha} [$H_\alpha$] and {\tt alpha} [$\alpha$] can be changed by modifying the file {\tt injectSignal.m}. It also generates the inverse {\tt invH} of {\tt H}, which is sometimes useful.

\newpage


\section{injectSignal.m}
\label{injectSignal.m}

\subsection*{Syntax:}

\begin{verbatim}
 Generates the product h1*(t,f)h2(t,f) directly for the supplied
 source map of the sky. h1(t,f),h2(t,f) are not calculated individually

 [ h1h2 ] = ...
   injectSignal (sourceMap, pixOmega, freqBins, H, deltaTime, detSep, Gamma)

 sourceMap  Real vector. Strengths of injected point sources at each pixel
 pixOmega   Real matrix. Array of direction cosines of pixels
            Index 1: pixel number, Index 2: axis
 freqBins   Vector. Position os frequency bins
 H          Real vector. Frequency power spectrum of the source
 deltaTime  Real. Width of time bins in sec
 detSep     Real matrix. Detector separation vector at all sideral times
            Index 1: Vector component, Index 2: sidereal time
 Gamma      Real matrix. Combination of antenna patterns for all directions
            and sideral times. Index 1: pixel, Index 2: sidereal time
            *** CAUTION: Gamma is NOT the full overlap reduction function ***

 h1h2       Complex matrix. Contains h1*(f)h2(f) at every time bin
            Index 1: time, Index 2: frequency
\end{verbatim}

\subsection*{Description:}

If the pixel coordinates {\tt pixOmega} [$\k_i$] and injected skymap {\tt sourceMap} [$\bm{\P}$] have the same length, given the detector separation vectors at all sidereal time bins {\tt detSep} [$\D(t)$] and the combination of antenna pattern functions {\tt Gamma} [$\Gamma(\k_i,t)$] for all pixels, this function simulates the expected correlation of the true gravitational wave strains in the detectors  {\tt h1h2} [$\langle \ft{h}^*_1(t;f) \, \ft{h}_2(t;f') \rangle$] using the formula
\begin{equation*}
\langle \ft{h}^*_1(t;f) \, \ft{h}_2(t;f) \rangle \ = \ H(|f|) \, \sum_i \P_i \,  \Gamma(\k_i,t) \, e^{2\pi \i f \k_i\cdot\D(t)/c}.
\end{equation*}

To get only the source PSD {\tt H} and its inverse {\tt invH} and {\em not} the simulated strain, use a blank input value {\tt []} for {\tt sourceMap}.

\newpage

\section{normalize.m}
\label{normalize.m}

\subsection*{Syntax:}
\begin{verbatim}
 Calculate the normalization constant for the beam at each pixel

 Lambda = normalize (Gamma, fSpectrum, deltaFreq, deltaTime)

 Gamma      Real matrix. Combination of antenna patterns for all directions
            and sideral times. Index 1: pixel, Index 2: sidereal time
            *** CAUTION: Gamma is NOT the full overlap reduction function ***
 fSpectrum  Real matrix. Combination of the source & detector PSDs 
            [GTilde(t,f) in text]. Index-1: Time, Index-2: frequency
 deltaTime  Real. Width of time bins in sec
 deltaFreq  Real. Width of frequency bins in Hz

 Lambda     Real vector. Normalization constant for each pixel
\end{verbatim}

\subsection*{Description:}
Compute the normalization constant {\tt 4 * variance} [$\Lambda_i$] using the relation
\begin{equation*}
\Lambda_i \ = \ \left[ 2 \, \T \sum_{t=0}^T \F \sum_{f=f_l}^{f_u} \, \frac{H^2(|f|) \, \Gamma^2(\k_i,t)} {P_1(t,|f|) \, P_2(t,|f|)} \right]^{-1}.
\end{equation*}
The normalization constant is applied only for writing output.

Note that, the variance at each pixel is proportional to the normalization constant:
\begin{equation*}
\sigma_i^2 \ = \ \Lambda_i/4.
\end{equation*}

\newpage

\section{makeRawMap.m}
\label{makeRawMap.m}

\subsection*{Syntax:}

\begin{verbatim}
 Make skymap from the Fourier transforms of chunks of time series data
 using the directed (radiometer) search algorithm

 dirtyMap = ...
  makeRawMap (s1s2, pixOmega, freqBins, detSep, Gamma, H, invP1, invP2)

 s1s2        Complex matrix. s1*(f) s2(f)
             Index 1: sidereal time, Index 2: frequency
 pixOmega    Real matrix. Array of direction cosines of pixels
             Index 1: pixel number, Index 2: axis
 freqBins    Real vector. Position os frequency bins
 detSep      Real matrix. Detector separation vector at all sideral times
             Index 1: Vector component, Index 2: sidereal time
 Gamma       Real matrix. Combination of antenna patterns for all directions
             and sideral times. Index 1: pixel, Index 2: sidereal time
             ***CAUTION: Gamma is NOT the full overlap reduction function***
 H           Real vector. Frequency power spectrum of the source
 invP1,invP2 Real matrices. Inverse of PSD of detectors at different times.
             Index 1: time, Index 2: frequency

 dirtyMap    Real vector. Raw correlation values at each pixel
\end{verbatim}

\subsection*{Description:}

Make an UNNORMALIZED dirty map from the product of Fourier transforms of detector output at different time chunks {\tt s1s2} [$\langle \ft{s}^*_1(t;f) \, \ft{s}_2(t;f) \rangle$] using the formula
\begin{equation*}
S_i \ := \ 2 \sum_{t=0}^T  \Re \left[ \F \sum_{f=f_l}^{f_u} \ft{s}_1^*(t,f) \, \ft{s}_2(t,f) \, \ft{q}_{\k_i}(t,f) \right],
\end{equation*}
where the filter is given by
\begin{equation*}
 \ft{q}_{\k}(t,f) \ = \ \frac{H(|f|) \, \Gamma(\k,t)}{P_1(t,|f|) \, P_2(t,|f|)} \, e^{-2\pi \i f \k\cdot\D(t)/c}.
\end{equation*}

\newpage

\section{beamMatrix.m}
\label{beamMatrix.m}

\subsection*{Syntax:}

\begin{verbatim}
 Calculate the UNNORMALIZED beam matrix

 b = beamMatrix (pixOmega, deltaTime, freqBins, fSpectrum, Gamma, detSep)

 pixOmega  Real matrix. Array of direction cosines of pixels
           Index 1: pixel number, Index 2: axis index
 deltaTime Real. Width of time bins.
 freqBins  Real vector. Position os frequency bins
 fSpectrum Real matrix. Combination of the source & detector PSDs 
           [GTilde(t,f) in text]. Index-1: Time, Index-2: frequency
 Gamma     Real matrix. Combination of antenna patterns for all directions
           and sideral times. Index 1: pixel, Index 2: sidereal time
           *** CAUTION: Gamma is NOT the full overlap reduction function ***
 detSep    Real matrix. Detector separation vector at all sideral times
           Index 1: Vector component, Index 2: sidereal time

 b         Real matrix. The beam matrix. Each index is a pixel number
\end{verbatim}

\subsection*{Description:}

This routine does not calculate anything directly. Since the unnormalized beam matrix is symmetric, it selects each element of the upper triangular part of the matrix one by one and calls another routine \link{beamMatrixElement} to compute that element. After the upper triangular part is computed, the lower triangular elements are filled by symmetry.

Since computation of the beam matrix is most time consuming part of this analysis, this is the function that has to be modified for parallel implementation.

\newpage

\section{beamMatrixElement.m}
\label{beamMatrixElement.m}

\subsection*{Syntax:}

\begin{verbatim}
 Calculate an UNNORMALIZED element of the beam matrix

 beamElement = beamMatrixElement ...
  (pixelRow, pixelCol, pixOmega, freqBins, fSpectrum, Gamma, detSep)

 pixelRow    Integer. Row pixel number of beam matrix
 pixelCol    Integer. Column pixel number of beam matrix
 pixOmega    Real matrix. Direction cosines of the pixels
             Index 1: pixel number, Index 2: axis index
 deltaTime   Real. Width of time bins.
 freqBins    Real vector. The frequency bin positions
 fSpectrum   Real matrix. Combination of the source & detector PSDs 
             [GTilde(t,f) in text]. Index-1: Time, Index-2: frequency
 Gamma       Real matrix. Combination of antenna patterns for all directions
             and sideral times. Index 1: pixel, Index 2: sidereal time
             ***CAUTION: Gamma is NOT the full overlap reduction function***
 detSep      Real matrix. Detector separation vector at all sideral times
             Index 1: Vector component, Index 2: sidereal time

 beamElement Real. Element of the beam matrix
\end{verbatim}

\subsection*{Description:}

Calculates one element of the unnormalized beam matrix with row {\tt pixelRow} [$i$] and column {\tt pixelCol} [$j$] using the formula
\begin{equation*}
b_{ij} \ := \ 2 \, \T \sum_{t=0}^T \Gamma(\k_j,t) \, \Gamma(\k_i,t) \, \Re \left[ \F \sum_{f=f_l}^{f_u} e^{2\pi \i f (\k_j-\k_i)\cdot\D(t)/c} G(t,f) \right].
\end{equation*}

\newpage

\section{deconvolve.m}
\label{deconvolve.m}

\subsection*{Syntax:}

\begin{verbatim}
 The deconvolve routine
 Currently uses MATLAB inbuilt or other third party routines

 cleanMap = deconvolve (b,dirtyMap)
 
 b              Real matrix. Unnormalized beam matrix
 dirtyMap       Real vector. Raw/dirty/concolved map of the sky
                Each component corresponds to a pixel

 cleanMap       Real vector. Estimated/clean/deconvolved map of the sky
                Each component corresponds to a pixel
\end{verbatim}

\subsection*{Description:}

Finally, we can estimate the Maximum Likelihood skymap {\tt cleanMap} [$\Pest$] by solving the following set of linear equations
\begin{equation*}
\sum_j b_{ij} \, \hat{\P}_j  \ = \ S_i/\Lambda_i.
\end{equation*}
However, both the unnormalized beam $\mathbf{b}$ and the dirty map $\mathbf{S}$ have the same normalization constant. So we may replace them by the unnormalized beam {\tt b} and dirty map {\tt dirtyMap} respectively in the above equation. It has the advantage that the ``kernel'' (the matrix) of the linear algebraic equation we are solving is now symmetric.

The default routine used to solve the equation is the MATLAB inbuilt minimum residual conjugate gradient numerically stabilized method ({\tt minres}). To change the default routine this file {\tt deconvolve.m} has to be modified. A long list is commented out in the file. One can also use the returns values of the main \link{mapEst} program to check different deconvolution methods. For example to try direct matrix inversion, simple use on the command line
\begin{verbatim}
cleanMap = inv(b) * dirtyMap;
\end{verbatim}

In the end, the deconvolved map {\tt cleanMap} [$\Pest$] should be compared to the injected map {\tt sourceMap} [$\bm{\P}$] to check the quality of deconvolution. Currently this is done by measuring the NMSE of the clean map:
\begin{equation*}
\text{NMSE} \ := \ \frac{|\bm{\P} \ - \ \Pest|^2}{|\bm{\P}|^2}.
\end{equation*}

\newpage

\chapter{Utilities}

\section{dirtyMapTest.m}
\label{dirtyMapTest.m}

\subsection*{Syntax:}
\begin{verbatim}
 Routine to compute beam pattern for a certain pointing direction (addNoise=0)
 OR to create a dirty map from simulated data with noise (addnoise!=0)

 [ theta, phi, sourceMap, dirtyMap, variance ] = dirtyMapTest ...
    (detector1, detector2, pixelFile, inputMap, addNoise, mapFile, projType)

 detector1      String. Detector name 1 (like 'L1', 'H1', ...)
 detector2      String. Detector name 2 (like 'L1', 'H1', ...)
 pixelFile      String. File containing the pixel coordinates in radian
                Column 1: longitude, Column 2: latitude
 inputMap       Real Matrix or String. Source map or filename
                Column 1: pixel numbers, Column 2: corresponding strength
 addNoise       Real. Multiply noise by this factor.
                NO noise is added if addNoise=0
 mapFile        String. File to write the maps to
 projType       String. Optional. If specified the skymaps will be plotted
                using that projType as the projection type, e.g., 'mollweid'

 theta          Real vector. Polar angles of the pixels
 phi            Real vector. Azimuthal angles of the pixels
 sourceMap      Real vector. (Optional) Injected map of the sky
 dirtyMap       Real vector. Raw/dirty/concolved map of the sky
                Each component corresponds to a pixel
 variance       Real vector. Variance at each pixel
\end{verbatim}

\newpage

\section{loadMap.m}
\label{loadMap.m}

\subsection*{Syntax:}
\begin{verbatim}
 Load map from file and UNNORMALIZE
 Useful for deconvolution only works

 [ theta, phi, sourceMap, dirtyMap, cleanMap, variance] = loadMap (mapFile)

 mapFile    String. File containing the maps

 theta      Real vector. Polar angle of the pixels
 phi        Real vector. Azimuthal angle of the pixels
 sourceMap  Real vector. The injected map
 dirtyMap   Real vector. The raw map
 cleanMap   Real vector. The clean map
 variance   Real vector. Normalization constants
\end{verbatim}

\newpage

\section{loadBeam.m}
\label{loadBeam.m}

\subsection*{Syntax:}

\begin{verbatim}
 Load beam from file and UNNORMALIZE
 Useful for deconvolution only works

 [ b, variance] = loadBeam (beamFile)

 mapFile    String. File containing the maps
 beamFile   String. File containing the beam

 b          Real matrix. The beam matrix
 variance   Real vector. Normalization constants
\end{verbatim}

\newpage

\section{loadMapBeam.m}
\label{loadMapBeam.m}

\subsection*{Syntax:}
\begin{verbatim}
 Load beam and maps from files and UNNORMALIZE
 Useful for deconvolution only works

 [ theta, phi, sourceMap, dirtyMap, cleanMap, variance, B] = ...
   loadMapBeam (mapFile, beamFile)

 mapFile    String. File containing the maps
 beamFile   String. File containing the beam

 theta      Real vector. Polar angle of the pixels
 phi        Real vector. Azimuthal angle of the pixels
 sourceMap  Real vector. The injected map
 dirtyMap   Real vector. The raw map
 cleanMap   Real vector. The clean map
 variance   Real vector. Normalization constants
 b          Real matrix. The beam matrix
\end{verbatim}

\newpage

\section{createFlatPixels.m}
\label{createFlatPixels.m}

\subsection*{Syntax:}
\begin{verbatim}
 Create a two dimensional array of pixels by dividing
 longitude and latitude in equal bins

 createFlatPixels (longBin, latBin, outFile)

 longBin   Integer. Number of longitude bins
 latBin    Integer. Number of latitude bins

 outFile   String. Output file.
           Column 1: longitude, Column 2: latitude (both in radians)
\end{verbatim}

\newpage

\section{selectPixels.m}
\label{selectPixels.m}

\subsection*{Syntax:}
\begin{verbatim}
 Select all the pixels within a given area bounded by latitude and longitudes
 The pixel indices are returned

 function [ listPix ] = ...
  selectPixels (theta, phi, minTheta, maxTheta, minPhi, maxPhi)

 theta    Real vector. Theta of all the pixels
 phi      real vector. Phi of all the pixels
 minTheta Real. Minimum theta
 maxTheta Real. Maximum theta
 minPhi   Real. Minimum phi
 maxPhi   Real. Maximum phi

 listPix  Integer vector. List of pixel numbers falling in the range
\end{verbatim}

\newpage

\newpage

\section{makeSmileyMap.m}
\label{makeSmileyMap.m}

\begin{verbatim}
 Make a smiley looking map of the sky, which can be used as injected map

 sourceMap = makeSmileyMap (theta, phi)

 theta     Real vector. Polar angles of the pixels
 phi       Real vector. Azimuthal angles of the pixels

 sourceMap Real vector. Returned smiley map
\end{verbatim}


\newpage

\section{randnPeter.m}
\label{randnPeter.m}

\subsection*{Syntax:}
\begin{verbatim}
 Use rand.m and use the Box-Muller method (Numerical Recipes, section 7.2)
 to transform to a gaussian distribution - by Peter Fritschel

 Npnt  Integer. Number of numbers in the sequence to be generated

 rslt  Real vector. The sequence of Gaussian random numbers
\end{verbatim}

\newpage

\section{xproject.m}
\label{xproject.m}
By: Shourov Chatterji, Albert Lazzarini, Antony Searle, Leo Stein, Patrick Sutton \& Massimo Tinto

\subsection*{Syntax:}

\begin{verbatim}
 XPROJECT Perform spherical or equal area projection of sky map data

 XPROJECT projects the given sky map data for viewing and printing.  Two types
 of projections are provided: A three dimensional projection onto a sphere,
 which may be interactively manipulated in the Matlab figure window, and a
 large variety of two dimensional projections.

 usage: 

   handle = xproject(skyPositions, skyMap, projectionType, channelNames);

   skyPositions       matrix of sky positions [radians]
   skyMap             vector of sky map data
   projectionType     projection type string (e.g. 'sphere' or 'mollweid')
   channelNames       cell array of channel name strings

   handle             handle to projected image

 The sky positions should be provided as a two column matrix of the form [theta
 phi], where theta is the geocentric colatitude running from 0 at the North
 pole to pi at the South pole and phi is the geocentric longitude in Earth
 fixed coordinates with 0 on the prime meridian.  The range of theta is [0, pi]
 and the range of phi is [-pi, pi).

 A projection type of 'sphere' produces an interactive three dimensional plot
 of the data on a sphere.  A projection type of 'unwrapped' produces an
 interactive three dimensional plot of the data in cos(baseline angle) space.
 A variety of two dimensional projections are also
 available through the Matlab mapping toolbox.  In particular, the projection
 type 'mollweid' produces the standard equal area Mollweide projection that is
 commonly used in astrophysical publications.  If no projection type is
 specified, XPROJECT assumes type 'sphere' by default.

 The optional cell array of channel name strings is used to label the detector
 zenith directions and pairwise detector baseline directions on spherical sky
 map plots.  If no channel names are specified, only the cartesian coordinate
 axes are labelled.

 See also XPIPELINE, XREADDATA, XINJECTSIGNAL, XCONDITION, XTILESKY, XMAPSKY
 XINTERPRET, and MAP.
\end{verbatim}

\end{document} 